/*
 * Copyright (C) 2012 ys7010 All Rights Reserved.
 * 
 * Merge sort Version 1.10
 */

/* wb_t@C */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "msort.h"

/* [U[`^ */
typedef struct {
    int sequence;
    int order;
    int dummy[8];
} OBJECT;

/* r֐ */
int cmpObject(const void *x, const void *y) {
    return ((OBJECT *)x)->order - ((OBJECT *)y)->order;
}

/* main֐ */
int main(void) {
    int i, n, max = 10000000;
    OBJECT *obj1, *obj2;
    clock_t start, end;

    srand((unsigned int)time(NULL));

    // Im
    obj1 = (OBJECT *)malloc(sizeof(OBJECT) * max);
    obj2 = (OBJECT *)malloc(sizeof(OBJECT) * max);

    for (n = 1; n <= max; n *= 10) {

        // z񏉊
        for (i = 0; i < n; i++) {
            obj1[i].sequence = i;
            obj1[i].order = rand();
        }
        memcpy(obj2, obj1, sizeof(OBJECT) * n);

        // qsorts
        start = clock();
        qsort(obj1, n, sizeof(OBJECT), cmpObject);
        end = clock();

        printf("--------------------\n");
        printf("\[g  Fqsort\n");
        printf("    F%d\n", n);
        printf("sԁF%.2fb\n",(double)(end - start) / CLOCKS_PER_SEC);

        // \[gmF
        for (i = 1; i < n; i++) {
            if (obj1[i].order == obj1[i - 1].order &&
                obj1[i].sequence < obj1[i - 1].sequence) {
                break;
            }
        }
        if (i == n) {
            printf("萫  F\[g\n");
        } else {
            printf("萫  F\[gł͂Ȃ\n");
        }

        // msorts
        start = clock();
        msort(obj2, n, sizeof(OBJECT), cmpObject);
        end = clock();

        printf("--------------------\n");
        printf("\[g  Fmsort\n");
        printf("    F%d\n", n);
        printf("sԁF%.2fb\n",(double)(end - start) / CLOCKS_PER_SEC);

        // \[gmF
        for (i = 1; i < n; i++) {
            if (obj2[i].order == obj2[i - 1].order &&
                obj2[i].sequence < obj2[i - 1].sequence) {
                break;
            }
        }
        if (i == n) {
            printf("萫  F\[g\n");
        } else {
            printf("萫  F\[gł͂Ȃ\n");
        }

        // \[gmF
        for (i = 0; i < n; i++) {
            if (obj2[i].order != obj1[i].order) {
                break;
            }
        }
        if (i == n) {
            printf("\[gF\[g܂\n");
        } else {
            printf("\[gF\[g܂łi%dԖځj\n", i);
        }
    }

    // I
    free(obj1);
    free(obj2);

    // ͑҂ԂŃXgbv
    getchar();

    return 0;
}
